<template>
  <div class="edit-currency fixed inset-0">
    <div class="h-full flex items-center justify-center">
      <div id="editCurrency" class="edit-currency__content xs:w-full bg-bgdsec p-8 xs:px-4 xs:pt-4 rounded-32">
        <div class="flex items-center justify-between">
          <p class="text-txtdprim font-bold text-2xl leading-7 xs:text-lg xs:leading-6">Edit Currency</p>
          <UiButton button-height="sm" color-type="secondary" class="w-12 rounded-16" @click="closeEditCurrency">
            <img width="24" height="24" src="@/assets/images/ui/ui-cross.svg" />
          </UiButton>
        </div>
        <div class="mt-8 flex gap-2 items-center">
          <p class="text-txtdsec font-medium">Currency Symbol</p>
        </div>
        <UiInput v-model="form.symbol" class="mt-4 rounded-16" />
        <div class="mt-8 flex gap-2 items-center">
          <p class="text-txtdsec font-medium">Currency Full Name</p>
        </div>
        <UiInput v-model="form.full_name" class="mt-4 rounded-16" />
        <div class="mt-8 flex gap-2 items-center">
          <p class="text-txtdsec font-medium">Currency Details</p>
        </div>
        <UiInput v-model="form.details" class="mt-4 rounded-16" />
        <UiButton
          :disabled="!form.full_name || !form.symbol || !form.details"
          class="w-full rounded-24 mt-8"
          @click="editCurrency"
        >
          <span v-if="!loading">Edit Currency</span>
          <LoadingSpinner color-type="white" v-else />
        </UiButton>
      </div>
    </div>
  </div>
</template>

<script>
import { editCurrency } from '@/api/admin';

import UiInput from '@/components/ui/UiInput.vue';
import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';
import UiButton from '@/components/ui/UiButton.vue';

export default {
  name: 'editCurrency',

  components: { UiButton, UiInput, LoadingSpinner },

  props: {
    currency: {
      type: Object,
      default: () => ({}),
    },
  },

  data() {
    return {
      form: {
        symbol: '',
        full_name: '',
        details: '',
      },

      loading: false,
    };
  },

  watch: {
    currency() {
      this.form = { ...this.currency, id: undefined };
    },
  },

  methods: {
    closeEditCurrency() {
      this.$emit('close');
    },

    async editCurrency() {
      this.loading = true;

      try {
        await editCurrency(this.currency.id, {
          symbol: this.form.symbol.toUpperCase(),
          full_name: this.form.full_name.charAt(0).toUpperCase() + this.form.full_name.slice(1),
          details: this.form.details,
        });
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'Currency successfully updated.',
        });
        this.closeEditCurrency();
        this.$emit('update-currencies');
      } catch (err) {
        console.error(err);
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'Error while updating currency.',
          status: 'error',
        });
      } finally {
        this.loading = false;
      }
    },
  },
};
</script>

<style lang="scss">
.edit-currency {
  background: rgba(12, 21, 33, 0.64);

  &__content {
    width: 500px;
  }
}
</style>
